// /////////////////////////////////////////////////////////////////////////
// C++ code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#include "../inc/multiplier.hpp"



multiplier::multiplier() :
    op2_old(uint16_t(0U)),
    op1_old(uint16_t(0U)),
    din_rdy_old(false),
    clk_old(false),
    hif_a2t_data(
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr),
    clkSuphif_1(false),
    clkSuphif_1_new(false),
    process_in_queue(false),
    flag_vhdl_process_UpdclkSuphif_1_executed(false),
    flag_clk(false)
{
}


multiplier::~multiplier()
{}


void multiplier::vhdl_process_UpdclkSuphif_1()
{
    if (*hif_a2t_data.clk != clkSuphif_1 && *hif_a2t_data.clk == true)
    {
        if (*hif_a2t_data.din_rdy == true)
        {
            *hif_a2t_data.result = *hif_a2t_data.op1 * *hif_a2t_data.op2;
            *hif_a2t_data.dout_rdy = true;
        }
        else
        {
            *hif_a2t_data.result = 0UL;
            *hif_a2t_data.dout_rdy = false;
        }
    }
    clkSuphif_1_new = *hif_a2t_data.clk;
}


void multiplier::update_input_queue( bool synch_phase )
{
    process_in_queue = false;
    if (*hif_a2t_data.clk != clk_old)
    {
        clk_old = *hif_a2t_data.clk;
        flag_clk = true;
        process_in_queue = true;
    }
    else
    {
        flag_clk = false;
    }
    din_rdy_old = *hif_a2t_data.din_rdy;
    op1_old = *hif_a2t_data.op1;
    op2_old = *hif_a2t_data.op2;
}


void multiplier::update_event_queue()
{
    process_in_queue = false;
    update_input_queue( false );
    clkSuphif_1 = clkSuphif_1_new;
}


void multiplier::flag_elaboration()
{
    flag_vhdl_process_UpdclkSuphif_1_executed = false;
    if (flag_clk)
    {
        vhdl_process_UpdclkSuphif_1();
        flag_vhdl_process_UpdclkSuphif_1_executed = true;
    }
}


void multiplier::start_of_simulation()
{
    vhdl_process_UpdclkSuphif_1();
    flag_vhdl_process_UpdclkSuphif_1_executed = true;
}


void multiplier::initialize()
{
    start_of_simulation();
}




